var Ctb22000_RazaoOficial_Controller = function(ScreenService, General) {

    this.preparaFiltroRazaoOficial = function(widget, preference){
        var filtro = preference.FILTER_ROW;
        var i = 0;
        var posData = [];
        widget.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA': filter.value = filtro.CDEMPRESA;
                    break;
                case 'CDCONTCTBLINI': filter.value = filtro.CDCONTCTBLINI;
                    break;
                case 'CDCONTCTBLFIN': filter.value = filtro.CDCONTCTBLFIN;
                    break;
                case 'DTINICIAL': filter.value = filtro.DTLANCCONT.start;
                    break;
                case 'DTFINAL': filter.value = filtro.DTLANCCONT.end;
                    break;
                case 'DTLANCCONT': posData.push(i);
                    break;
                case 'NMEMPRESA': posData.push(i);
                    break;
                case 'NMCONTCTBLINI': posData.push(i);
                    break;
                case 'NMCONTCTBLFIN': posData.push(i);
                    break;
                
            }
            i++;
        });
        posData.sort();
        var qtde = posData.length;
        for (var j = 1; qtde > j; j++){
            widget.dataSourceFilter.splice(posData[qtde - j], 1);
        }
    };
    
    /*
     * Função chamada pela tela ao ser aberta.
     * Seta a máscara de conta contábil buscada da PARAMGERAL na variável.
     */
    this.setContctblMask = function() {
        // Chama a rota que retorna os dados da PARAMGERAL.
        General.callRestEngine("ctb#/crud/paramgeral", "FilterData", []).then(function(response) {
            // Busca o primeiro dado retornado, que será o único registro da parametrização.
            var paramgeral = response.dataset.paramgeral[0];

            // Armazena o valor da máscara na variável.
            contctblMask = paramgeral.CDPICTCCTB;
        });
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Ctb22000_RazaoOficial_Controller', Ctb22000_RazaoOficial_Controller);
});